package api.common.pojo.dto;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * {
 *  "projectId": "sadfasdfs", // 项目 id
 *  "algorithmId": "sadfasdfs", // 算法 id
 *  "vehicleId": "sadfasdfs", // 车辆 id
 *  "scenePackageId": "sadfasdfs", // 场景包 id
 *  "maxSimulationTime": 11111, // 最大仿真时间
 *  "parallelism": 30  // 并行度
 * }
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ProjectMessageDTO {

    private String projectId;// 项目 id
    private String algorithmId;// 算法 id
    private String vehicleConfigId;// 车辆配置 id
    private String scenePackageId;// 场景包 id
    private int maxSimulationTime;// 最大仿真时间（秒）
    private int parallelism;// 并行度，创建 pod 时使用

}
