package com.css.simulation.resource.monitor.controller;

import api.common.pojo.common.ResponseBodyVO;
import com.css.simulation.resource.monitor.scheduler.ProjectScheduler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@Controller
@RequestMapping("/projectTask")
public class ProjectTaskCtrl {

    @Autowired
    ProjectScheduler scheduler;

    @RequestMapping("/init")
    @ResponseBody
    public ResponseBodyVO init(@RequestBody List<ProjectScheduler.ProjectTask> task){
        int count = scheduler.init(task);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,count);
    }


    @RequestMapping("/start")
    @ResponseBody
    public ResponseBodyVO start(@RequestBody ProjectScheduler.ProjectTask task){
        boolean b = scheduler.start(task);
        if(b){
            return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
        }
        return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE);
    }

    @RequestMapping("/stop")
    @ResponseBody
    public ResponseBodyVO stop(@RequestBody ProjectScheduler.ProjectTask task){
        boolean b = scheduler.stop(task);
        if(b){
            return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
        }
        return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE);
    }

    @RequestMapping("/destroy")
    @ResponseBody
    public ResponseBodyVO destroy(){
        scheduler.destroy();
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }
}
