package com.css.simulation.resource.scheduler.manager;

import com.css.simulation.resource.scheduler.mapper.IndexMapper;
import com.css.simulation.resource.scheduler.pojo.po.LeafIndexPO;
import org.apache.ibatis.session.ExecutorType;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class TaskIndexManager {

    @Autowired
    private SqlSessionFactory sqlSessionFactory;

    public void batchInsertLeafIndex(List<LeafIndexPO> leafTaskIndexList) {

        try(SqlSession sqlSession = sqlSessionFactory.openSession(ExecutorType.BATCH,false)){
            IndexMapper indexMapper = sqlSession.getMapper(IndexMapper.class);
            for (LeafIndexPO leafIndexPO : leafTaskIndexList) {
                indexMapper.insertLeafIndex(leafIndexPO);
            }
            sqlSession.commit();
        }
    }
}
