package com.css.simulation.resource.scheduler.manager;

import api.common.pojo.constants.DictConstants;
import com.css.simulation.resource.scheduler.mapper.TaskMapper;
import org.apache.ibatis.session.ExecutorType;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.sql.Timestamp;

@Component
public class TaskManager {

    @Autowired
    private SqlSessionFactory sqlSessionFactory;

    public void updateFailStateWithStopTime(String taskId, String runState, Timestamp runStopTime) {

        try (SqlSession sqlSession = sqlSessionFactory.openSession(ExecutorType.BATCH, false)) {
            TaskMapper taskMapper = sqlSession.getMapper(TaskMapper.class);
            taskMapper.updateFailStateWithStopTime(taskId, runState, runStopTime,DictConstants.TASK_ERROR_REASON_2);
            taskMapper.updateProjectStateByTaskId(DictConstants.PROJECT_TERMINATED, taskId);
            sqlSession.commit();
        }
    }
}
