package com.css.simulation.resource.scheduler.mapper;


import com.css.simulation.resource.scheduler.pojo.po.AlgorithmPO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;

/**
 * 场景查询
 * scene_natural
 * scene_standard
 * scene_accident
 */
@Mapper
public interface AlgorithmMapper {

    @Results(id = "index", value = {
            @Result(column = "minio_path", property = "minioPath", jdbcType = JdbcType.VARCHAR),
            @Result(column = "docker_import", property = "dockerImport", jdbcType = JdbcType.VARCHAR),
            @Result(column = "docker_image", property = "dockerImage", jdbcType = JdbcType.VARCHAR)
    })
    @Select("select minio_path,\n" +
            "   docker_import,\n" +
            "   docker_image,\n" +
            "   upload_mode\n" +
            "from algorithm\n" +
            "where is_deleted = '0'\n" +
            "  and id = #{id}")
    AlgorithmPO selectById(@Param("id") String id);

    @Update("update algorithm\n" +
            "set docker_import = #{dockerImport},\n" +
            "    docker_image  = #{dockerImage}\n" +
            "where id = #{algorithmId}")
    void updateDockerImportAndDockerImageById(@Param("dockerImport") String dockerImport, @Param("dockerImage") String dockerImage, @Param("algorithmId") String algorithmId);
}
