package com.css.simulation.resource.feign;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.RedisParameter;
import com.css.simulation.resource.common.config.FeignConfiguration;
import com.css.simulation.resource.feign.fallback.RedisServiceFallback;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;
import java.util.Map;

//@FeignClient(name = "test", url = "http://10.15.12.72:8001", fallback = RedisServiceFallback.class, configuration = FeignConfiguration.class)
//@FeignClient(name = "test1", url = "http://47.93.217.159", path = "/simulation/resource/common", fallback = RedisServiceFallback.class, configuration = FeignConfiguration.class)
@FeignClient(value = "simulation-resource-common",
        contextId = "redis",
        path = "/simulation/resource/common",
        fallback = RedisServiceFallback.class,
        configuration = FeignConfiguration.class)
public interface RedisService {

    @PostMapping("/redis/setDictLists")
    ResponseBodyVO<String> setDictLists(List<RedisParameter> redisParameter);

    @PostMapping("/redis/setDictMaps")
    ResponseBodyVO<String> setDictMaps(List<RedisParameter> redisParameter);

    @PostMapping("/redis/getDictLists")
    ResponseBodyVO<Map<String,String>> getDictLists(List<String> keyList);

    @PostMapping("/redis/getDictMaps")
    ResponseBodyVO<Map<String,String>> getDictMaps(List<String> keyList);

    @PostMapping(value = "/redis/get")
    ResponseBodyVO<String> getProgress(RedisParameter redisParameter);

}