package com.css.simulation.resource.feign;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.po.system.SceneImportPO;
import com.css.simulation.resource.common.config.FeignConfiguration;
import com.css.simulation.resource.feign.fallback.SceneServiceFallback;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.scheduling.annotation.Async;
import org.springframework.web.bind.annotation.PostMapping;



@FeignClient(value = "simulation-resource-scene",
        contextId = "scene",
        path = "/simulation/resource/scene",
        fallback = SceneServiceFallback.class,
        configuration = FeignConfiguration.class)
public interface SceneService {

    @Async
    @PostMapping("/sceneImport/startImport")
    ResponseBodyVO startImport(SceneImportPO po);

}
