package com.css.simulation.resource.project.service;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.project.SimulationManualProjectParam;
import org.springframework.web.bind.annotation.RequestBody;


public interface SimulationProjectService {

    ResponseBodyVO addOrUpdateProject(SimulationManualProjectParam param);

    ResponseBodyVO selectProject(SimulationManualProjectParam param);

    ResponseBodyVO selectProjectById(SimulationManualProjectParam param);

    ResponseBodyVO deleteProjectByids(SimulationManualProjectParam param);

    ResponseBodyVO updateProjectNowRunState(SimulationManualProjectParam param);

    ResponseBodyVO selectProjectDetailsById(SimulationManualProjectParam param);

    ResponseBodyVO selectProjectReportById(SimulationManualProjectParam param);

    ResponseBodyVO selectDropDownByType(SimulationManualProjectParam param);

    ResponseBodyVO selectProjectTaskById(SimulationManualProjectParam param);

    ResponseBodyVO selectMaxParallelism();

    String getDictName(String type, String code);

    ResponseBodyVO analysisVehicleCoord() throws Exception;

    ResponseBodyVO selectProjectTaskList(SimulationManualProjectParam param);

    ResponseBodyVO selectRunProjectBySy();

    ResponseBodyVO selectRunTaskBySy();

    ResponseBodyVO selectRunTaskByState();

    ResponseBodyVO selectRunProjectByState();

    ResponseBodyVO selectEvaluationLevel();

    void exportProjectReport(SimulationManualProjectParam param);

    //根据算法id获取最新的一条报告id
    String selectProjectReportIdByAlgorithmId(String algorithmId);

    //生成保存评价等级
    ResponseBodyVO saveEvaluationLevel(SimulationManualProjectParam param);

    //仿真结果保存到数据库
    ResponseBodyVO saveTaskResult(SimulationManualProjectParam param);

    void exportProjectTaskFileById(SimulationManualProjectParam param);

    void exportProjectReportAndTaskFileById(SimulationManualProjectParam param);

    ResponseBodyVO addOrUpdateAutomaticProject(SimulationManualProjectParam param);

    ResponseBodyVO deleteAutomaticProjectByids(SimulationManualProjectParam param);

    ResponseBodyVO updateAutomaticRunState(SimulationManualProjectParam param);

    ResponseBodyVO selectAutomaticProject(SimulationManualProjectParam param);

    ResponseBodyVO createAutomaticSubProject(SimulationManualProjectParam param);

    ResponseBodyVO deleteAutomaticSubProjectByIds(SimulationManualProjectParam param);

    ResponseBodyVO selectSubProjectInfo(SimulationManualProjectParam param);

    ResponseBodyVO selectSubProjectList(SimulationManualProjectParam param);

    ResponseBodyVO selectAutomaticProjectById(SimulationManualProjectParam param);

    ResponseBodyVO updateAutoProjectNowRunState(SimulationManualProjectParam param);

}
