package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.scene.SystemScenePackageParam;
import api.common.pojo.po.scene.ScoringRulesPO;
import api.common.pojo.po.scene.SystemScenePackageNewPO;
import api.common.pojo.po.scene.SystemScenePackagePO;
import api.common.pojo.vo.scene.SystemScenePackageVO;
import api.common.pojo.vo.scene.SystemUserSceneVO;
import api.common.util.ObjectUtil;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.scene.service.SystemScenePackageService;
import com.github.pagehelper.PageInfo;
import org.springframework.web.bind.annotation.*;
import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

//场景包
@RestController
@RequestMapping("/SystemScenePackage")
public class SystemScenePackageController {

    @Resource
    SystemScenePackageService systemScenePackageService;

    //查询列表
    @PostMapping("/querySystemScenePackageList")
    @ResponseBody
    public ResponseBodyVO<List<SystemScenePackageVO> > querySystemScenePackageList(@RequestBody SystemScenePackageParam parms) {
        PageUtil.setPageInfo(parms);
        List<SystemScenePackageVO>  list = systemScenePackageService.querySystemScenePackageList(parms);

        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,  new PageInfo(list));
    }

    //查询场景包详情
    @PostMapping("/querySystemScenePackageById")
    @ResponseBody
    public ResponseBodyVO<SystemScenePackageNewPO> querySystemScenePackageById(@RequestBody SystemScenePackageParam parms) {
        if (ObjectUtil.isNull(parms.getId())) {
            return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE, "参数id不能为空，请检查");
        }
        SystemScenePackageNewPO po = systemScenePackageService.querySystemScenePackageById(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS, po);

    }

    //新增打分规则
    @PostMapping("/saveSystemScenePackage")
    @ResponseBody
    public ResponseBodyVO<String> saveSystemScenePackage(@RequestBody SystemScenePackageNewPO parms) {
        systemScenePackageService.saveSystemScenePackage(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }


    //删除
    @PostMapping("/deleteSystemScenePackage")
    @ResponseBody
    public ResponseBodyVO<String> deleteScoringRules(@RequestBody SystemScenePackagePO params) {
        systemScenePackageService.deleteSystemScenePackage(params);
        return new ResponseBodyVO<>(ResponseBodyVO.Response.SUCCESS);
    }

    //编辑场景包
    @PostMapping("/updateSystemScenePackage")
    @ResponseBody
    public ResponseBodyVO<List<ScoringRulesPO>> updateSystemScenePackage(@RequestBody SystemScenePackageNewPO params) {
        systemScenePackageService.updateSystemScenePackage(params);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    //场景包配置账号查询
    @PostMapping("/queryUserByPackageId")
    @ResponseBody
    public ResponseBodyVO<SystemUserSceneVO> queryUserByPackageId(@RequestBody SystemScenePackageNewPO params) {
        SystemUserSceneVO vo=  systemScenePackageService.queryUserByPackageId(params);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,vo);
    }
    //场景包配置账号添加
    @PostMapping("/saveUserByPackageId")
    @ResponseBody
    public ResponseBodyVO<String> saveUserByPackageId(@RequestBody SystemUserSceneVO params) {
         systemScenePackageService.saveUserByPackageId(params);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }
    //场景包配置账号删除
    @PostMapping("/deleteUserByPackageId")
    @ResponseBody
    public ResponseBodyVO<String> deleteUserByPackageId(@RequestBody SystemUserSceneVO params) {
        systemScenePackageService.deleteUserByPackageId(params);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    //场景包配置场景列表
    @PostMapping("/queryPackageList")
    @ResponseBody
    public ResponseBodyVO<List<Map>> queryPackageList() {
        List<Map> list=  systemScenePackageService.queryPackageList();
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,list);
    }

    //人员添加场景包
    @PostMapping("/savePackageByUserId")
    @ResponseBody
    public ResponseBodyVO<String> savePackageByUserId(@RequestBody SystemUserSceneVO params) {
        systemScenePackageService.savePackageByUserId(params);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }
    //配置账号删除场景包
    @PostMapping("/deletePackageByUserId")
    @ResponseBody
    public ResponseBodyVO<String> deletePackageByUserId(@RequestBody SystemUserSceneVO params) {
        systemScenePackageService.deletePackageByUserId(params);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    //人员场景包列表
    @PostMapping("/queryPackageByUserIdList")
    @ResponseBody
    public ResponseBodyVO<String> queryPackageByUserIdList(@RequestBody SystemScenePackageParam parms) {
            PageUtil.setPageInfo(parms);
            List<SystemScenePackageVO>  list = systemScenePackageService.queryPackageByUserIdList(parms);

            return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,  new PageInfo(list));
    }
}