package com.css.simulation.resource.scene.service;


import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.scene.SceneGeneralTemplateParam;
import api.common.pojo.vo.scene.SceneGeneralTemplateMbVO;
import api.common.pojo.vo.scene.SceneGeneralTemplateVO;
import api.common.util.JsonUtil;
import api.common.util.ObjectUtil;
import api.common.util.StringUtil;
import api.common.util.TimeUtil;
import com.css.simulation.resource.common.utils.AuthUtil;
import com.css.simulation.resource.scene.mapper.SceneGeneralTemplateMapper;
import api.common.pojo.po.scene.SceneGeneralTemplatePO;
import com.css.simulation.resource.system.service.DictService;
import com.fasterxml.jackson.core.JsonProcessingException;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.usermodel.*;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.*;

@Slf4j
@Service
public class SceneGeneralTemplateService {

    @Resource
    SceneGeneralTemplateMapper mapper;
    @Autowired
    DictService dictService;

    /**
     * 泛化模板导入：
     *//*
    @SneakyThrows
    public ResponseBodyVO<String> saveSceneGeneralTemplate1() {
            //同时支持Excel 2003、2007
            File excelFile = new File("D:\\配置参数表样例0415.xlsx"); //创建文件对象
            String fileName=    excelFile.getName();//文件名
        //  String fileName=   excelFile.getAbsolutePath();//文件地址
            // File excelFile = new File("D:\\0414.xlsx"); //创建文件对象
            FileInputStream is = new FileInputStream(excelFile); //文件流
            Workbook workbook = WorkbookFactory.create(is); //这种方式 Excel 2003/2007/2010 都是可以处理的
            int sheetCount = workbook.getNumberOfSheets();  //Sheet的数量
        List<SceneGeneralTemplatePO> list=new ArrayList<>();
        //遍历每个Sheet
            for (int s = 0; s < sheetCount; s++) {
                Sheet sheet = workbook.getSheetAt(s);
              // String aqq=sheet.getSheetName();  //文件Sheet的名称
                int rowCount = sheet.getPhysicalNumberOfRows(); //获取总行数
                //效验sheet页是否符合标准
                Cell ce00 = sheet.getRow(0).getCell(0);
                ce00.setCellType(Cell.CELL_TYPE_STRING);
                 String   c00Value = ce00.getStringCellValue();
                 System.out.println("测试是否符合---"+c00Value);
                 if(c00Value!=null&&c00Value.equals("场景编号")) {
                     //遍历每一行
                     for (int r = 0; r < rowCount; r++) {
                         Row row = sheet.getRow(r);
                         int cellCount = row.getPhysicalNumberOfCells(); //获取总列数
                         SceneGeneralTemplatePO po = new SceneGeneralTemplatePO();
                         Field[] field = po.getClass().getDeclaredFields();
                         //遍历每一个单元格
                         for (int c = 0; c < cellCount; c++) {
                             int a = c + 1;
                             Cell cell = row.getCell(c);
                             String cellValue = null;
                             //在读取单元格内容前,设置所有单元格中内容都是字符串类型
                             cell.setCellType(Cell.CELL_TYPE_STRING);
                             //按照字符串类型读取单元格内数据
                             cellValue = cell.getStringCellValue();
                             *//*在这里可以对每个单元格中的值进行二次操作转化*//*
                             //    System.out.print(cellValue + "    ");
                             if (r > 0) {
                                 //获取属性的名字
                                 String name = field[a].getName();
                                 //将属性名的第一位字母大写
                                 name = name.substring(0, 1).toUpperCase() + name.substring(1);
                                 //调用setter方法设属性值
                                 Class[] parameterTypes = new Class[1];
                                 parameterTypes[0] = field[a].getType();
                                 Method getOrSet = po.getClass().getDeclaredMethod("set" + name, parameterTypes);
                                 getOrSet.invoke(po, cellValue);
                             }
                         }
                         System.out.println();
                         if (r > 0) {
                             po.setCreateTime(TimeUtil.getNowForMysql());
                             po.setCreateUserId(AuthUtil.getCurrentUserId());
                             po.setModifyUserId(AuthUtil.getCurrentUserId());
                             po.setModifyTime(TimeUtil.getNowForMysql());
                             po.setIsDeleted("0");
                             po.setId(StringUtil.getRandomUUID());
                             po.setFileName(fileName);
                             list.add(po);
                         }
                     }
                 }
            }
            if(ObjectUtil.isNotNull(list)){
                mapper.deleteSceneGeneralTemplateAll(list.get(0));
                mapper.saveSceneGeneralTemplateAll(list);
                return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
            }
        return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE, fileName+"模板解析失败，请检查模板");
    }

*/
    /**
     * 泛化模板导入：
     */
    @SneakyThrows
    public ResponseBodyVO<String> saveSceneGeneralTemplate(File excelFile,String version) {
        FileInputStream is = new FileInputStream(excelFile); //文件流
        Workbook workbook = WorkbookFactory.create(is); //这种方式 Excel 2003/2007/2010 都是可以处理的
        int sheetCount = workbook.getNumberOfSheets();  //Sheet的数量
        List<SceneGeneralTemplatePO> list=new ArrayList<>();
        List<String> fileNameAll=new ArrayList<>();
        //遍历每个Sheet
        for (int s = 0; s < sheetCount; s++) {
            Sheet sheet = workbook.getSheetAt(s);
            String sheetName = sheet.getSheetName();  //文件Sheet的名称
            //验证模板名称是否正确  filrName为字典中的类别名
           /* Map<String, String> map = dictService.getDictMapByType("fileName");
            String fileName = map.get(sheetName);
            if (ObjectUtil.isNotNull(fileName)) {*/
            int rowCount = sheet.getPhysicalNumberOfRows(); //获取总行数
            //效验sheet页是否符合标准
            Cell ce00 = sheet.getRow(0).getCell(0);
            //ce00.setCellType(CellType.STRING);
            String c00Value = ce00.getStringCellValue();
            if (c00Value != null && c00Value.equals("场景编号")) {
                //遍历每一行
                for (int r = 1; r < rowCount; r++) {
                    Row row = sheet.getRow(r);
                    int cellCount = row.getPhysicalNumberOfCells(); //获取总列数
                    SceneGeneralTemplatePO po = new SceneGeneralTemplatePO();
                    Field[] field = po.getClass().getDeclaredFields();
                    //遍历每一个单元格
                    for (int c = 0; c < cellCount; c++) {
                        int a = c + 1;
                        Cell cell = row.getCell(c);
                        String cellValue = null;
                        if (r > 0 && c == 3) {
                            Date aaa = cell.getDateCellValue();
                            cellValue = TimeUtil.getToStringDate(aaa, 4);
                        } else {
                            //在读取单元格内容前,设置所有单元格中内容都是字符串类型
                            cell.setCellType(CellType.STRING);
                            //按照字符串类型读取单元格内数据
                            cellValue = cell.getStringCellValue();
                        }
                        /*在这里可以对每个单元格中的值进行二次操作转化*/
                        //    System.out.print(cellValue + "    ");
                        if (r > 0) {
                            //获取属性的名字
                            String name = field[a].getName();
                            //将属性名的第一位字母大写
                            name = name.substring(0, 1).toUpperCase() + name.substring(1);
                            //调用setter方法设属性值
                            Class[] parameterTypes = new Class[1];
                            parameterTypes[0] = field[a].getType();
                            Method getOrSet = po.getClass().getDeclaredMethod("set" + name, parameterTypes);
                            getOrSet.invoke(po, cellValue);
                        }
                    }
                    System.out.println();
                    if (r > 0) {
                        po.setCreateTime(TimeUtil.getNowForMysql());
                        po.setCreateUserId(AuthUtil.getCurrentUserId());
                        po.setModifyUserId(AuthUtil.getCurrentUserId());
                        po.setModifyTime(TimeUtil.getNowForMysql());
                        po.setIsDeleted("0");
                        po.setId(StringUtil.getRandomUUID());
                        po.setFileName(sheetName);
                        po.setVersion(version);
                        fileNameAll.add(sheetName);
                        list.add(po);
                    }
                }
            }
        //}
        }
        if(ObjectUtil.isNotNull(list)){
            SceneGeneralTemplatePO po=list.get(0);
            po.setFileNameAll(fileNameAll);
            mapper.deleteSceneGeneralTemplateAll(po);
            mapper.saveSceneGeneralTemplateAll(list);
            return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
        }
        return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE, "模板解析失败，请检查模板");
    }

    public List<SceneGeneralTemplatePO> querySceneGeneralTemplateList(SceneGeneralTemplateParam po) {
        List<SceneGeneralTemplatePO> list=mapper.querySceneGeneralTemplateList(po);
     Map<String,String>  scenarioRoadTypeMap= dictService.getDictMapByType("scenarioRoadType");
        Map<String,String>  scenarioWeatherMap= dictService.getDictMapByType("scenarioWeather");
        for (SceneGeneralTemplatePO vo : list) {
            vo.setScenarioRoadType(scenarioRoadTypeMap.get(vo.getScenarioRoadType()));
            vo.setScenarioWeather(scenarioWeatherMap.get(vo.getScenarioWeather()));
        }
        return   list;

    }
    @SneakyThrows
    public SceneGeneralTemplateVO querySceneGeneralTemplateById(String id){
        SceneGeneralTemplatePO po=mapper.querySceneGeneralTemplateById(id);
       String generalizationType =JsonUtil.stringToJson(po.getGeneralizationType());
       po.setGeneralizationType(generalizationType);
        SceneGeneralTemplateVO vo=new SceneGeneralTemplateVO();
       //转换为vo
        BeanUtils.copyProperties(po, vo);
        List<SceneGeneralTemplateMbVO>  listMb=new ArrayList<>();
        if(po.getObsStartX().indexOf(";")!=-1){
            listMb= spliceVo(po);
        }else{
            SceneGeneralTemplateMbVO  mbVO=new SceneGeneralTemplateMbVO();
            BeanUtils.copyProperties(po, mbVO);
            mbVO.setGeneralizationType(po.getGeneralizationType());
            listMb.add(mbVO);
        }
        vo.setListMb(listMb);
        vo.setTemplateId(vo.getId());
        return vo;

    }

    public   List<SceneGeneralTemplateMbVO> spliceVo(SceneGeneralTemplatePO po) throws JsonProcessingException {
        List<SceneGeneralTemplateMbVO>  listMb=new ArrayList<>();
        String[]  obsStartX= po.getObsStartX().split(";");
        String[]  obsStartY= po.getObsStartY().split(";");
        String[]  obsStartVelocity= po.getObsStartVelocity().split(";");
        String[]  obsLateralAcceleration= po.getObsLateralAcceleration().split(";");
        String[]  obsLongitudinalAcceleration= po.getObsLongitudinalAcceleration().split(";");
        String[]  obsHeadingAngleRel= po.getObsHeadingAngleRel().split(";");
        String[]  obsVelocityStatus= po.getObsVelocityStatus().split(";");
        String[]  obsTrajectory= po.getObsTrajectory().split(";");
        String[]  obsDurationTime= po.getObsDurationTime().split(";");
        String[]  obsVelocityTime= po.getObsVelocityTime().split(";");
        String[]  obsTrailTime= po.getObsTrailTime().split(";");

        String generalizationType=po.getGeneralizationType();
        List<String> list= Arrays.asList(obsStartX);
        for (int i=0;i<list.size();i++){
            SceneGeneralTemplateMbVO  mbVO=new SceneGeneralTemplateMbVO();
            mbVO.setObsStartX(list.get(i));
            mbVO.setObsStartY(obsStartY[i]);
            mbVO.setObsStartVelocity(obsStartVelocity[i]);
            mbVO.setObsLateralAcceleration(obsLateralAcceleration[i]);
            mbVO.setObsLongitudinalAcceleration(obsLongitudinalAcceleration[i]);
            mbVO.setObsHeadingAngleRel(obsHeadingAngleRel[i]);
            mbVO.setObsVelocityStatus(obsVelocityStatus[i]);
            mbVO.setObsTrajectory(obsTrajectory[i]);
            mbVO.setObsDurationTime(obsDurationTime[i]);
            mbVO.setObsVelocityTime(obsVelocityTime[i]);
            mbVO.setObsTrailTime(obsTrailTime[i]);
            Map<String,Integer> map=JsonUtil.jsonToMap(generalizationType);
            for(Map.Entry<String,Integer> entry:map.entrySet()){
                String value= entry.getValue().toString();
                if(value.length()>1){
              Integer values=Integer.parseInt(value.substring(i,i+1));
                    map.put(entry.getKey(),values);
                }
            }
            mbVO.setGeneralizationType(JsonUtil.beanToJson(map));
            listMb.add(mbVO);
        }
        return listMb;

    }


    public  ResponseBodyVO<String> deleteSceneGeneralTemplateById(SceneGeneralTemplatePO po) {
        po.setModifyUserId(AuthUtil.getCurrentUserId());
        po.setModifyTime(TimeUtil.getNowForMysql());
        mapper.deleteSceneGeneralTemplateAll(po);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);


    }

}
