package com.css.simulation.resource.system.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.constants.DictConstants;
import api.common.pojo.param.system.SceneImportPageParam;
import api.common.pojo.po.system.SceneImportPO;
import api.common.util.ObjectUtil;
import com.css.simulation.resource.feign.SceneService;
import com.css.simulation.resource.system.service.SceneImportService;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.context.request.RequestContextHolder;

import javax.annotation.Resource;

@Controller
@RequestMapping("/sceneImport")
public class SceneImportCtrl {

    @Autowired
    SceneImportService sceneImportService;

    @Resource
    SceneService sceneService;

    /**
     * 保存上传任务
     */
    @RequestMapping("/saveTask")
    @ResponseBody
    public ResponseBodyVO saveTask(@RequestBody SceneImportPO po) {
        if(ObjectUtil.isNull(po)){
            return new ResponseBodyVO(false, 500, "参数错误！",null);
        }
        String sceneType = po.getSceneType();
        if(ObjectUtil.isNull(sceneType) || DictConstants.SCENE_GENERAL.equals(sceneType)){
            return new ResponseBodyVO(false, 500, "参数错误！",null);
        }
        po = sceneImportService.saveTask(po);
        if(ObjectUtil.isNull(po.getId())){
            return new ResponseBodyVO(false, 500, "任务名称重复！",null);
        }
        ResponseBodyVO<SceneImportPO> response = new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
        response.setInfo(po);
        //异步-启动上传
        RequestContextHolder.setRequestAttributes(RequestContextHolder.getRequestAttributes(),true);
        sceneService.startImport(po);
        return response;
    }

    //查询列表
    @RequestMapping("/getSceneImporPagetList")
    @ResponseBody
    public ResponseBodyVO<PageInfo<SceneImportPO>> getSceneImporPagetList(@RequestBody SceneImportPageParam param) {
        ResponseBodyVO<PageInfo<SceneImportPO>> response = new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
        response.setInfo(sceneImportService.getSceneImporPagetList(param));
        return response;
    }

}
